# XSParticle Class Reference

Inheritance diagram for XSParticle:

List of all members.

## Public Types

enum | TERM_TYPE { TERM_EMPTY = 0, TERM_ELEMENT = XSConstants::ELEMENT_DECLARATION, TERM_MODELGROUP = XSConstants::MODEL_GROUP_DEFINITION, TERM_WILDCARD = XSConstants::WILDCARD }

## Public Member Functions

Constructors
| XSParticle (TERM_TYPE termType, XSModel *const xsModel, XSObject *const particleTerm, XMLSize_t minOccurs, XMLSize_t maxOccurs, bool unbounded, MemoryManager *const manager)
| The default constructor.
Destructor
| ~XSParticle ()
XSParticle methods
XMLSize_t | getMinOccurs () const
| [min occurs]: determines the minimum number of terms that can occur.
XMLSize_t | getMaxOccurs () const
| [max occurs] determines the maximum number of terms that can occur.
bool | getMaxOccursUnbounded () const
| [max occurs] whether the maxOccurs value is unbounded.
TERM_TYPE | getTermType () const
| Returns the type of the [term]: one of TERM_EMPTY, TERM_ELEMENT, TERM_MODELGROUP, or TERM_WILDCARD.
XSElementDeclaration * | getElementTerm ()
| If this particle has an [element declaration] for its term, this method returns that declaration; otherwise, it returns 0.
XSModelGroup * | getModelGroupTerm ()
| If this particle has a [model group] for its term, this method returns that definition; otherwise, it returns 0.
XSWildcard * | getWildcardTerm ()
| If this particle has an [wildcard] for its term, this method returns that declaration; otherwise, it returns 0.

## Protected Attributes

TERM_TYPE | fTermType
XMLSize_t | fMinOccurs
XMLSize_t | fMaxOccurs
bool | fUnbounded
XSObject * | fTerm

## Member Enumeration Documentation

enum XSParticle::TERM_TYPE

Enumerator:

  TERM_EMPTY |
  TERM_ELEMENT |
  TERM_MODELGROUP |
  TERM_WILDCARD |

## Constructor & Destructor Documentation

XSParticle::XSParticle | ( | TERM_TYPE | termType,
|  | XSModel *const | xsModel,
|  | XSObject *const | particleTerm,
|  | XMLSize_t | minOccurs,
|  | XMLSize_t | maxOccurs,
|  | bool | unbounded,
|  | MemoryManager *const | manager |
| ) |  |  |

The default constructor.

Parameters:

  | termType |
  | xsModel |
  | particleTerm |
  | minOccurs |
  | maxOccurs |
  | unbounded |
  | manager | The configurable memory manager

XSParticle::~XSParticle | ( |  | ) |

## Member Function Documentation

XMLSize_t XSParticle::getMinOccurs | ( |  | ) | const

[min occurs]: determines the minimum number of terms that can occur.

References fMinOccurs.

XMLSize_t XSParticle::getMaxOccurs | ( |  | ) | const

[max occurs] determines the maximum number of terms that can occur.

To query for value of unbounded use `maxOccursUnbounded`.

References fMaxOccurs.

bool XSParticle::getMaxOccursUnbounded | ( |  | ) | const

[max occurs] whether the maxOccurs value is unbounded.

References fUnbounded.

XSParticle::TERM_TYPE XSParticle::getTermType | ( |  | ) | const

Returns the type of the [term]: one of TERM_EMPTY, TERM_ELEMENT, TERM_MODELGROUP, or TERM_WILDCARD.

References fTermType.

XSElementDeclaration* XSParticle::getElementTerm | ( |  | ) |

If this particle has an [element declaration] for its term, this method returns that declaration; otherwise, it returns 0.

Returns:
  The element declaration that is the [term] of this Particle if and only if getTermType() == TERM_ELEMENT.

XSModelGroup* XSParticle::getModelGroupTerm | ( |  | ) |

If this particle has a [model group] for its term, this method returns that definition; otherwise, it returns 0.

Returns:
  The model group that is the [term] of this Particle if and only if getTermType() == TERM_MODELGROUP.

XSWildcard* XSParticle::getWildcardTerm | ( |  | ) |

If this particle has an [wildcard] for its term, this method returns that declaration; otherwise, it returns 0.

Returns:
  The wildcard declaration that is the [term] of this Particle if and only if getTermType() == TERM_WILDCARD.

## Member Data Documentation

TERM_TYPE XSParticle::fTermType`[protected]`

Referenced by getTermType().

XMLSize_t XSParticle::fMinOccurs`[protected]`

Referenced by getMinOccurs().

XMLSize_t XSParticle::fMaxOccurs`[protected]`

Referenced by getMaxOccurs().

bool XSParticle::fUnbounded`[protected]`

Referenced by getMaxOccursUnbounded().

XSObject* XSParticle::fTerm`[protected]`

The documentation for this class was generated from the following file:

- XSParticle.hpp